This is a port of term 1.08 to Mint and Mint-Net.

Things needed to run term 1.08:
-------------------------------

o	term 1.08 for Mint and Mint, of cource

o	Mint-Net 0.2 or better.

o	modm0dev (atari.archive:/atari/Mint/Devices/modm0dev.zoo).
	You can use every serial device driver that supports select().
	NOTE that Mint built in drivers (u:/dev/modem*, u:/dev/serial*)
	DO NOT work, because select() on them is broken. Therefore you need
	modm0dev.

Additinal things you need to compile:
-------------------------------------

o	MintLibs PL 41 and gcc != 2.3.3 PL 1.

Changes to stock term 1.08:
---------------------------

Because Mint-Net does not yet support inet-sockets, all the TCP/IP
related functionality in term has been commented out. This means tredir
will not work. All the other current clients (trsh, tupload, tmon, txconn)
do work. They have been testet against Linux term 1.08 at 19200 baud.

Txconn already creates /tmp/.X11-unix/X?, its a pitty we have no X11
for Atari's :-). If someone gets to compile libX11.a and libXt.a, you
could compile X11 clients on your Atari and redirect the Output over
term to your Sun or Linux box :-).

If you are intrested in how I tested txconn, here we go: I redirected
screen 2 from my Linux X11 via txconn to the Atari screen 0. And on the
Atari I redirected screen 0 via txconn to screen 0 of my Linux box.
And, guys, it was slow over a 19200 line, but it did really work!

There are two general bug fixes in pty.c and link.c (not term for Mint
specific). They are marked with ++kay and should be applied to new releases
of term.

There is a known bug in term 1.08, which is triggered by (for instance)
'trsh -s ls' for long dirs. This will not print the whole remote directory
listing, the last bytes are missing. This is because term stops to read
data from its clients when they *terminate*, not when read() from them
returns EOF. This is a general bug in term (not introduced in my port),
which should be fixed really soon.

The file mint.c contains replacements for the Mint-Libs read() and write()
functions (they emulate O_NONBLOCK nonblocking mode).
There is also a replacement for 'if (fork()) exit();' called __fork_and_exit().
This is because Mint's fork() blocks the parent. Used in connect.c.

Changes have been made in pty.c to use Mint's pseudo terminals and to
avoid a bug in MintLib's dup2().

Txconn has been configured to use local unix connections, ie /tmp/.X11-unix/X?.

Term is configured to use termios, setsid, tc[s|g]etattr, ...
Better have a look at config.h.

Term is configured to use 4096 (instead of 2048) byte large client buffers,
because I had input buffer overflow errors at 19200 baud with trsh on the
Atari console. (perhaps caused by the slow console select(); the kernel
checks for select on the console only at context switches).
This should be enough, if not you will get error messages like
'ADD_BUFF: buffer overflow ...' in your log file. Then you need to increase
BUFFER_SIZE in client.h. This was a terrible bug to find, because initially
there were no checks for buffer overflow and the results looked really
strange :(

Term is configured to allow a maximum of 16 concurrent clients. This should
be enough for most purposes and saves us about 200 kB of memory!
If you have enough physical mem or even VM, then you can increase MAX_CLIENTS
in term.h.

How to install:
---------------

You should have installed Mint, Mint-Net and modm0dev. Read the installation
instructions coming with them.

Read all the Readme's, Install's and Manual Pages in the term archive.

Set $HOME to your home directory. Make a directory called .term in $HOME.
(On 8+3 filesystems this is called .ter). Copy the TERMRC file from the
term archive to $HOME/.term/termrc. Run linecheck to determine which
characters should be escaped and edit the termrc file. Then run
./term -v /dev/ttyd0 -l term.log -d 64&. This makes term write debugging
output to term.log.

Do similar things on the remote end. Now you should be able to run trsh.
If it doesn't work escape/ignore more characters and look at the term.log
file. Read the term README once more :-).

Ah, and don't forget to set line speeds, for instance with
$ stty 19200 < /dev/ttyd0

If you have tried at least 4 hours and it still doesn't work, don't
hesitate to contact me at the below given addresses.

Notes:
------

Term was compiled with gcc 2.4.2 and linked with the MintLibs PL 41
and SocketLib 0.2 PL 1.
The code in lib.o produced with gcc 2.3.3 and -O2 is broken. It
crashes trsh...


Please send bug reports to ...

Email:	roemer@rbi.informatik.uni-frankfurt.de
IRC:	kay_

Have fun,
Kay Roemer.
